import * as fs from "fs";
import * as path from "path";

async function getFromFetch(url) {
    let response = await fetch(url, {method: "get"});
    if (!response.ok) throw new Error(`Status code is ${response.status}`);
    return Buffer.from(await response.arrayBuffer());
}

async function getFromFs(Path) {
    return fs.readFileSync(path.resolve(Path));
}

export function isUrl(string) {
    let url;
    try {
        url = new URL(string);
    } catch (_) {
        // try {
        //     url = new URL("http://" + string);
        // }
        // catch (_) {
            return false;
        // }
    }
    return url.protocol === "http:" || url.protocol === "https:";
}

export default async function getFile(url) {
    return isUrl(url) ? getFromFetch(url) : getFromFs(url);
}

// getFile("https://tsairuthvik.com/images/lang.jpg").then(data => fs.writeFileSync("./test0.jpg", data));
// getFile("S:\\Kali bg\\kali-red-sticker-16x9.jpg").then(data => fs.writeFileSync("./test1.jpg", data));
// console.log(isUrl("index.js"));